global.bullet2 = object_add();

object_event_add(global.bullet2, ev_create, 0, "
    depth = 1;
");

object_event_add(global.bullet2, ev_step, ev_step_end, "
    lifetime -= 1;
    image_alpha = 0.35+image_alpha*0.52;
    hitDamage *= 0.85;
    speed *= 0.9
    if (lifetime <= 0) {
	instance_destroy();
	exit;
    }

    var x1,y1,x2,y2,xm,ym, len;
    var hitline;
    var bulletHit;
    bulletHit = id;
    len=speed;
    x1=xprevious;
    y1=yprevious;
    x2=x;
    y2=y;
    
    while(len>1) {
        xm=(x1+x2)/2;
        ym=(y1+y2)/2;
        
        hitline = false;
        if (collision_line(x1,y1,xm,ym,Generator,true,true)>=0) {
            if !collision_line(x1,y1,xm,ym,Generator,true,true).team == owner.team
		hitline = true;
        }
        if(collision_line(x1,y1,xm,ym,Obstacle,true,true)>=0) {
            hitline = true;
        } else if (collision_line(x1,y1,xm,ym,Bubble,true,true)>=0) {
	    if collision_line(x1,y1,xm,ym,Bubble,true,true).owner.team != owner.team
		hitline = true;
        } else if (collision_line(x1,y1,xm,ym,Character,true,true)>=0) {
	    if collision_line(x1,y1,xm,ym,Character,true,true).team != owner.team
		hitline = true;
        } else if (collision_line(x1,y1,xm,ym,Sentry,true,false)>=0) {
	    if collision_line(x1,y1,xm,ym,Sentry,true,true).team != owner.team
		hitline = true;
        } else if (collision_line(x1,y1,xm,ym,TeamGate,true,true)>=0) {
            hitline = true;
        } else if (collision_line(x1,y1,xm,ym,ControlPointSetupGate,true,true)>=0) {
            if ControlPointSetupGate.solid == true hitline = true;
        } else if (collision_line(x1,y1,xm,ym,BulletWall,true,true)>=0) {
            hitline = true;
        }
        
        if(hitline) {
            x2=xm;
            y2=ym;
 	    lifetime = 0;
	    x=x2;
	    y=y2;
        } else {
            x1=xm;
            y1=ym;
        }
        len/=2;
    }

    with(Bubble) {
        if(owner.team != other.owner.team) {
            if(collision_line(other.x,other.y,x2,y2,id,false,false)>=0) {
		instance_destroy();
                exit;
            }
        }
    }

    with(Player) {
        if(id != other.ownerPlayer and team != other.owner.team and object != -1) {
            if(collision_line(other.x,other.y,x2,y2,object,true,false)>=0) && object.ubered == 0 {
                object.hp -= other.hitDamage;
                object.timeUnscathed = 0;
                if (object.lastDamageDealer != other.ownerPlayer && object.lastDamageDealer != object.player){
                    object.secondToLastDamageDealer = object.lastDamageDealer;
                    object.alarm[4] = object.alarm[3]
                }
                object.alarm[3] = ASSIST_TIME;
                object.lastDamageDealer = other.ownerPlayer;
                object.cloakAlpha = max(object.cloakAlpha, 0.3);
                object.cloakFlicker = true;
                object.alarm[7] = 3;
		with (object) motion_add(bulletHit.direction, bulletHit.speed/150);
                if(global.gibLevel > 0){
                    blood = instance_create(object.x,object.y,Blood);
                    blood.direction = other.direction-180;
                }
                if (!other.owner.zoomed)
                    object.lastDamageSource = other.weapon;
                else
                    object.lastDamageSource = other.weapon;
                exit;
            }
        }
    }
    
    with(Sentry) {
        if(team != other.owner.team) {
            if(collision_line(other.x,other.y,x2,y2,id,false,false)>=0) {
                hp -= other.hitDamage;
                lastDamageDealer = other.ownerPlayer;
                if (!other.owner.zoomed)
                    lastDamageSource = other.weapon;
                else
                    lastDamageSource = other.weapon;
		with instance_create(x2,y2,Impact)
		    image_angle = other.direction;
                exit;
            }
        }
    }
    
    with(Generator) {
        if(team != other.owner.team) {
            if(collision_line(other.x,other.y,x2,y2,id,true,false)>=0) {
                alarm[0] = regenerationBuffer;
                isShieldRegenerating = false;
                //allow overkill to be applied directly to the target
                if (other.hitDamage > shieldHp) {
                    hp -= other.hitDamage - shieldHp;
                    hp -= shieldHp * shieldResistance;
                    shieldHp = 0;
                }
                else
                {
                    hp -= other.hitDamage * shieldResistance;
                    shieldHp -= other.hitDamage;
                }
		with instance_create(x2,y2,Impact)
		    image_angle = other.direction;
                exit;
            }
        }
    }
    
    if (lifetime == 0) {
	with instance_create(x2,y2,Impact)
	    image_angle = other.direction;
    }
");

object_event_add(global.bullet2, ev_draw, 0, "
    draw_set_alpha(image_alpha);
    draw_line_color(xprevious, yprevious, x, y, c_white, image_blend);
    draw_set_alpha(1);
");

object_event_add(Shot, ev_step, ev_step_begin, "
    var shot2;
    shot2 = (instance_create(xstart,ystart,global.bullet2));
    shot2.direction = direction;
    shot2.owner = owner;
    shot2.ownerPlayer = ownerPlayer;
    shot2.team = team;
    shot2.weapon = weapon;
    shot2.lifetime = 9*((min(1, abs(cos(degtorad(other.owner.aimDirection)))*13 / abs(cos(degtorad(other.owner.aimDirection))*13+owner.hspeed))-1)/2+1);
    shot2.hitDamage = hitDamage*1.3;
    shot2.speed = 65+random(35);
    shot2.image_blend = c_yellow;
    if (sprite_index == ShotGoldS)
	image_blend = make_color_rgb(irandom(255),irandom(255),irandom(255));
    instance_destroy();
");